aboutsummaryrefslogtreecommitdiff
path: root/misc/flips
diff options
context:
space:
mode:
authorSteven Voges <svoges.sbo@gmail.com>2023-04-08 02:48:33 +0100
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2023-04-08 09:16:29 +0700
commit3778c05d69fd31402d665195f0457eca270ad906 (patch)
tree9a2c2caa0db22dede53eb485678d62bd8126829e /misc/flips
parent965f8b1316bba277274442c6e0700d857016fa46 (diff)
misc/flips: Added (Rom patching utility)
Signed-off-by: bedlam <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'misc/flips')
-rw-r--r--misc/flips/README18
-rw-r--r--misc/flips/doinst.sh9
-rw-r--r--misc/flips/flips.SlackBuild119
-rw-r--r--misc/flips/flips.info10
-rw-r--r--misc/flips/slack-desc19
5 files changed, 175 insertions, 0 deletions
diff --git a/misc/flips/README b/misc/flips/README
new file mode 100644
index 000000000000..2f667835cd2c
--- /dev/null
+++ b/misc/flips/README
@@ -0,0 +1,18 @@
+Floating IPS (or Flips) is a patcher for IPS and BPS files, aiming for
+a simple interface yet plenty of power under the hood.
+
+Features:
+
+ * Creates the smallest BPS patches of any known tool in existence,
+ and is faster than any other comparable creator
+ * Creates the smallest IPS patches of any known tool in existence,
+ too (but only a little smaller, Lunar IPS is quite good)
+ * Fully-featured GUIs under Windows and GTK+, including command line
+ support; can also be a pure command line program
+ * Can apply multiple patches to the same ROM, creating a huge pile
+ of ROMs (GUI only)
+ * Can remembers which ROMs you've used, and use them again if it
+ thinks it's correct (BPS only, GUI only)
+ * Can launch other programs after patching the ROMs; together with
+ the above, this allows you to double click a BPS to launch an
+ emulator (GUI only)
diff --git a/misc/flips/doinst.sh b/misc/flips/doinst.sh
new file mode 100644
index 000000000000..65c7e2eeb9aa
--- /dev/null
+++ b/misc/flips/doinst.sh
@@ -0,0 +1,9 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/misc/flips/flips.SlackBuild b/misc/flips/flips.SlackBuild
new file mode 100644
index 000000000000..a31b52a24851
--- /dev/null
+++ b/misc/flips/flips.SlackBuild
@@ -0,0 +1,119 @@
+#!/bin/bash
+
+# Slackware build script for flips
+
+# Copyright 2023 Steven Voges <Oregon, USA>
+# Copyright 2016, 2018 Hunter Sezen California, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=flips
+SRCNAM=Flips
+VERSION=${VERSION:-20230315_fdd5c6e}
+SRCVER=${SRCVER:-fdd5c6e34285beef5b9be759c9b91390df486c66}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$SRCVER
+tar xvf $CWD/$SRCNAM-$SRCVER.tar.gz
+cd $SRCNAM-$SRCVER
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS='-Wall -O3 -flto -fuse-linker-plugin -fomit-frame-pointer -fmerge-all-constants -fvisibility=hidden'
+CFLAGS=$CFLAGS' -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables'
+CFLAGS=$CFLAGS' -ffunction-sections -fdata-sections -Wl,--gc-sections -fprofile-dir=obj/'
+CFLAGS=$CFLAGS' -Wl,-z,relro,-z,now,--as-needed,--hash-style=gnu,--relax'
+TARGET=gtk make CFLAGS="$FLAGS$LINFLAGS -fprofile-generate -lgcov" || exit $?
+[ -e flips ] || exit 1
+export OMP_NUM_THREADS=1 # -fprofile-generate isn't thread safe
+/usr/bin/time -v ./flips --create --bps-delta profile/firefox-10.0esr.tar profile/firefox-17.0esr.tar /dev/null
+/usr/bin/time -v ./flips --create --bps-delta-moremem profile/firefox-10.0esr.tar profile/firefox-17.0esr.tar /dev/null
+rm flips
+TARGET=gtk make CFLAGS="$FLAGS$LINFLAGS -fprofile-use" || exit $?
+install -vDm0755 $PRGNAM $PKG/usr/bin/${PRGNAM}
+install -vDm0644 data/com.github.Alcaro.$SRCNAM.desktop $PKG/usr/share/applications/$PRGNAM.desktop
+install -vDm0644 data/com.github.Alcaro.$SRCNAM.svg \
+ $PKG/usr/share/icons/hicolor/scalable/apps/com.github.Alcaro.$SRCNAM.svg
+for name in bps flips ips; do
+ for i in 0 1 2; do
+ convert ${name}.ico[${i}] ${name}-$((48-${i}*16)).png
+ install -vDm0644 ${name}-$((48-${i}*16)).png \
+ $PKG/usr/share/icons/hicolor/$((48-${i}*16))x$((48-${i}*16))/apps/${name}.png
+ done
+done
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ *.md COPYING* \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/misc/flips/flips.info b/misc/flips/flips.info
new file mode 100644
index 000000000000..74625fbc070d
--- /dev/null
+++ b/misc/flips/flips.info
@@ -0,0 +1,10 @@
+PRGNAM="flips"
+VERSION="20230315_fdd5c6e"
+HOMEPAGE="https://github.com/Alcaro/Flips"
+DOWNLOAD="https://github.com/Alcaro/Flips/archive/fdd5c6e34285beef5b9be759c9b91390df486c66/Flips-fdd5c6e34285beef5b9be759c9b91390df486c66.tar.gz"
+MD5SUM="8f6e99b283122ca74231044bf24ba04e"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/misc/flips/slack-desc b/misc/flips/slack-desc
new file mode 100644
index 000000000000..05b8b6c86d16
--- /dev/null
+++ b/misc/flips/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+flips: flips (Rom patching utility)
+flips:
+flips: Floating IPS is a patcher for IPS and BPS files.
+flips:
+flips: Homepage: https://github.com/Alcaro/Flips
+flips:
+flips:
+flips:
+flips:
+flips:
+flips: